class Power {
  // instance variables
  double b;
  int e;
  double value;

  // constructor definition that takes two formal parameters
  Power(double b, int e) {
  // by default, if a local variable has the same name as an instance variable (field)
  // use "this" to un-hide instance variables
    // b = b would fail to assign a value
    // to the instance variable
    // so it would remain zero
    this.b = b;
    this.e = e;

    this.value = 1; // instance variable
    if(e==0) return;
    for( ; e>0; e--)
    {
      value = value * b;
    }
  }

  // method definition
  double getPower() {
    return value;
  }
}

class DemoPowerWithThis {
  public static void main(String args[]) {
    // instantiate objects of type Power
    Power x = new Power(4.0, 2);
    Power y = new Power(2.5, 1);
    Power z = new Power(5.7, 0);

    System.out.println(x.b + " raised to the " + x.e +
       " power is " + x.getPower()); // calling a method on an object
    System.out.println(y.b + " raised to the " + y.e +
       " power is " + y.getPower());
    System.out.println(z.b + " raised to the " + z.e +
       " power is " + z.getPower());
  }
}



class Pwr {
  double b;
  int e;
  double val;

  Pwr(double base, int exp) {
    this.b = base;
    this.e = exp;

    this.val = 1;
    if(exp==0) return;
    for( ; exp>0; exp--) this.val = this.val * base;
  }

  double get_pwr() {
    return this.val;
  }
}