// encapsulate the agent data and methods in this class
class SpecialAgent
{
 	static int salary = 100; // field class level
 	int iQ = 100; // instance variable
 	int bonus = 50; // instance level
 	//field
  	// define the parameterless constructor
	SpecialAgent()
	{
		System.out.println("nameless special agent ");
  	}
  	// define the constructor with a single string parameter
  	SpecialAgent(String name)
  	{
  		System.out.println("Constructing " + name);
  	}
  	// formal parameter is initialSalary
  	SpecialAgent(int initialSalary)
	{
	   // field gets the value of the parameter
	  salary = initialSalary;
	  System.out.println("Initial salary " + salary);
  	}
  	// void is the return type when no value is returned
  	void useGadget(String gadgetName) // method definition
  	{
		System.out.println("using gadget " + gadgetName);
	}
	// to return an int, a return statment is on line 33
	int getSalary() // method definition
	{
		return salary;
	}
}
// runtime
class ParameterizedConstructorDemoWithComments {
  public static void main(String[] args) {
	// get the number of chars in a string literal
	System.out.println("Hello".length());
    // pass an argument to a method on an unnamed object
    new SpecialAgent().useGadget("no-name gadget");
    // construct an object using the constructor that takes a string
    SpecialAgent agent007 = new SpecialAgent("James Bond");
    SpecialAgent agent001 = new SpecialAgent(88); // goes to the constructor on line 19
    System.out.println("agent001.salary is -- Hopefully 88? " + agent001.salary);
    System.out.println("agent007.salary is " + agent007.salary);
    System.out.println("agent007.salary is " + SpecialAgent.salary);
    System.out.println(5); // runtime argument passed to method
    System.out.println(agent007.getSalary());
    agent007.useGadget("wetsuit with duck on top for stealth");
    SpecialAgent agent86 = new SpecialAgent("Maxwell Smart");
    agent86.useGadget("shoe-phone");
    System.out.println("agent007.salary is " + agent007.salary);
    agent86.iQ = 93;
    System.out.println(agent86.iQ);

  }
}