/* copy by reference only works for objects, not primitives */
class Employee
{
	String name = "";
}
class CopyByReferenceNameDemo
{
  public static void main(String[] args)
  {
      Employee e1 = new Employee();
      /* make two objects refer to the same location in memory
         so a change of either one changes the other one */
      Employee e2 = e1; // two object variables points to same object

      e1.name = "Jimi";
      System.out.println(e2.name);

      e1.name = "Hendrix";
      System.out.println(e2.name);
      System.out.println("changing e1.name also changes e2.name \nbecause the two instance variables point to \nthe same String in memory.");
      e2.name = "e2.name";
      System.out.println("The value of e1.name is now " + e1.name);

      // primitives copy by value, not by reference
      int yourVal = 0;
      int myVal = 10;
      System.out.println("myVal is now: " + myVal);
      /* the following does not make myVal point to yourVal */
      myVal = yourVal;
      System.out.println("myVal is now: " + myVal);
      yourVal = yourVal + 100; // yourVal not coupled to myVal
      System.out.println("yourVal + 100 affects only yourval: " + yourVal);
      System.out.println("myVal remains " + myVal);
  }
}