class Power
{
  double b;
  int e;
  double value;

  Power(double base, int exponent)
  { // keyword "this" allows field and parameter
    // to use the same identifier
    this.b = base;
    e = exponent;

    value = 1;
    if(exponent==0) return;
    for( ; exponent>0; exponent--)
    {
      value = value * base;
    }
  }

  double getPower()
  {
    return value;
  }
}

class DemoPower
{
  public static void main(String[] args)
  {
    Power x = new Power(4.0, 2);
    Power y = new Power(2.5, 1);
    Power z = new Power(5.7, 0);

    System.out.println(x.b + " raised to the " + x.e +
       " power is " + x.getPower());
    System.out.println(y.b + " raised to the " + y.e +
       " power is " + y.getPower());
    System.out.println(z.b + " raised to the " + z.e +
       " power is " + z.getPower());
  }
}