class Phone
{
	//final int SPEED_LIMIT = 160; // a constant
	String color = "blue"; // field for any object of this type
	                       // also called an instance variable

	// in this constructor definition, color is one of the two formal parameters
	Phone(String phoneNumber, String color)
	{
		// in the call to the println method, phoneNumber is a runtime argument
		System.out.println(phoneNumber);
		/* this.color references the field for THIS particular phone that is being constructed right now */
		System.out.println(this.color);
		/* To assign the value of the parameter named color to the field named color, we unhide the field name by explictly referring to "this" object being constructed. We can only use the dot (.) operator on an object. We cannot use the dot operator on the formal parameter. */
		this.color = color;
		System.out.println(color);
	}
	void makeACall()
	{
		System.out.println("makeACall method has been called");
		if(false) return;
		System.out.println("keep going");
	}
}
class Bed
{
	Bed(int numberOfOccupants)
	{
		System.out.println(numberOfOccupants);
	}
	// every method must have a return type
	boolean isMade(boolean stateOfBed)
	{
		System.out.println(stateOfBed);
		return stateOfBed;
	}
}
class DemoTwoClasses
{
	public static void main(String[] args)
	{
		// pass two runtime arguments to the constructor
		// the "red" argument will be stored on line 8 as a formal parameter
		Phone myPhone = new Phone("4153566783", "red");
		myPhone.makeACall();
		Bed myBed = new Bed(2);
		myBed.isMade(true);
		System.out.println("all methods have been called");
	}
}